=== debian/changelog ===
hipfft (6.4.3-2) unstable; urgency=medium

  * Re-upload to unstable with orginal tarball

 -- Cordell Bloor <cgmb@debian.org>  Mon, 10 Nov 2025 08:34:10 -0700

hipfft (6.4.3-1) unstable; urgency=medium

  [ Cordell Bloor ]
  * Upload to unstable
  * Remove Maxime Chambonnet from uploaders
  * Update my email address and copyright information
  * Add d/p/fix-optional-hiprand.patch and build with USE_HIPRAND=OFF
    to remove use of hiprand from the hipfft tests
  * Enable CMAKE_SKIP_INSTALL_RPATH to use rpath for build-time tests
  * Use GPU_TARGETS rather than deprecated AMDGPU_TARGETS
  * Add prompt for rocminfo output to library and test bug reports

  [ Kentaro Hayashi ]
  * Use d/watch 5

 -- Cordell Bloor <cgmb@debian.org>  Sat, 08 Nov 2025 14:12:11 -0700

hipfft (6.4.3-1~exp1) experimental; urgency=medium

  * New upstream version 6.4.3
  * Update for new rocm-target-arch

 -- Christian Kastner <ckk@debian.org>  Sat, 09 Aug 2025 09:46:47 +0200

hipfft (6.4.1-1~exp2) experimental; urgency=medium

  * Improve the run-tests runner
  * Use rocm-target-arch to select and document GPU arch
  * d/rules: Fix typo in DEB_BUILD_PROFILES envvar name
  * Update repo layout to DEP-14

 -- Christian Kastner <ckk@debian.org>  Fri, 11 Jul 2025 16:44:21 +0200
