=== debian/control ===
Source: hipfft
Section: devel
Homepage: https://github.com/ROCm/hipfft
Priority: optional
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/rocm-team/hipfft.git
Vcs-Browser: https://salsa.debian.org/rocm-team/hipfft
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Cordell Bloor <cgmb@debian.org>,
           Christian Kastner <ckk@debian.org>,
           Kari Pahula <kaol@debian.org>,
Build-Depends: debhelper-compat (= 13),
               hipcc (>= 5.6.1~),
               cmake,
               rocm-cmake,
               librocfft-dev (>= 6.4.1~),
               libboost-program-options-dev <!nocheck>,
               libfftw3-dev <!nocheck>,
               libgtest-dev <!nocheck>,
               pkg-rocm-tools (>= 0.9.0~exp3),
Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
               python3-doxysphinx <!nodoc>,
               python3-rocm-docs (>= 1.20.0-1~) <!nodoc>,
               python3-sphinx-external-toc <!nodoc>,
               libjs-jquery <!nodoc>,
               libjs-mathjax <!nodoc>,
               libjs-sphinxdoc <!nodoc>,
               libjs-underscore <!nodoc>
Rules-Requires-Root: no

Package: libhipfft0
Section: libs
Architecture: amd64 arm64 ppc64el
XB-X-ROCm-GPU-Architecture: ${rocm:GPU-Architecture}
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: portable interface for Fast Fourier Transforms on the GPU - library
 hipFFT is a wrapper library that provides a common interface to rocFFT and
 cuFFT. The hipFFT library is designed to help applications using cuFFT to port
 their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipFFT library.

Package: libhipfft-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: libhipfft0 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
         libamdhip64-dev,
Suggests: libhipfft-doc
Description: portable interface for Fast Fourier Transforms on the GPU - headers
 hipFFT is a wrapper library that provides a common interface to rocFFT and
 cuFFT. The hipFFT library is designed to help applications using cuFFT to port
 their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipFFT development headers.

Package: libhipfft0-tests
Section: libdevel
Architecture: amd64 arm64 ppc64el
Build-Profiles: <!nocheck>
Depends: libhipfft0 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
Description: portable interface for Fast Fourier Transforms on the GPU - tests
 hipFFT is a wrapper library that provides a common interface to rocFFT and
 cuFFT. The hipFFT library is designed to help applications using cuFFT to port
 their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipFFT test binaries. These binaries are
 only used to check whether hipFFT works correctly on a given GPU, so
 generally speaking, users probably don't need this package.

Package: libhipfft-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax,
Breaks: libhipfft-dev (<< 5.7.1-1~)
Replaces: libhipfft-dev (<< 5.7.1-1~)
Description: portable interface for Fast Fourier Transforms on the GPU - documentation
 hipFFT is a wrapper library that provides a common interface to rocFFT and
 cuFFT. The hipFFT library is designed to help applications using cuFFT to port
 their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipFFT documentation.
