=== debian/tests/control ===
Test-Command: rocm-test-launcher /usr/libexec/rocm/libhipfft0-tests/run-tests
Features: test-name=libhipfft0-tests
Depends: pkg-rocm-tools, libhipfft0-tests
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 ppc64el
