=== debian/watch ===
Version: 5

Source: https://github.com/rocm/hipfft/tags
Matching-Pattern: (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hipfft-$1.tar.gz%
