## hipfft 7.1.0

=== debian/changelog ===
hipfft (7.1.0-0ubuntu3) resolute; urgency=medium

  * No change rebuild due to rocrand upgrade 

 -- Igor Luppi <igor.luppi@canonical.com>  Sat, 14 Feb 2026 15:29:31 -0300

hipfft (7.1.0-0ubuntu2) resolute; urgency=medium

  * d/control: update build-deps w/ llvm-21
  * d/rules: fix hipfft-doc build
  * d/patches: drop doxygen-refs.patch
  * d/patches: add new fix-doxygen-refs.patch
  * d/patches: add new bump-rocm-docs-core-in-docs-sphinx.patch
  * d/patches: add new add-so-version-for-libhipfftw0.patch
  * d/control: new binary package libhipfftw0
  * d/control: add libhipfftw0 as dependency of libhipfft-dev and
    libhipfft0-tests
  * d/rules: use DPKG_GENSYMBOLS_CHECK_LEVEL = 4
  * d/{tests/control,control}: remove ppc64el arch

 -- Bojan Aleksovski <bojan.aleksovski@canonical.com>  Tue, 03 Feb 2026 22:31:06 +0100

hipfft (7.1.0-0ubuntu1) resolute; urgency=medium

  [Talha Can Havadar]
  * d/{rules,control,patches}: make hiprand not optional

  [Alexandre Erwin Ittner]
  * New upstream release.
  * d/patches: remove Switch-find_package-to-module-mode.patch
  * d/control: update Maintainer and Homepage
  * d/libhipfft0.install: include libhipfftw.so*
  * d/libhipfft0.symbols.amd64: include fftw* symbols

 -- Alexandre Erwin Ittner <alexandre.ittner@canonical.com>  Tue, 09 Dec 2025 19:41:45 +0000

hipfft (6.4.3-1~exp1ubuntu1) UNRELEASED; urgency=medium

  * d/control: update maintainer field
  * d/control: update build-depends
  * d/rules: fix FTBFS by adding -Wl,--gc-sections to flags
  * d/rules: use GPU_TARGETS instead of deprecated AMDGPU_TARGETS

 -- Igor Luppi <igor.luppi@canonical.com>  Tue, 28 Oct 2025 09:34:02 -0300
