=== debian/control ===
--- 
+++ 
@@ -1,26 +1,29 @@
 Source: hipfft
 Section: devel
-Homepage: https://github.com/ROCm/hipfft
+Homepage: https://github.com/ROCm/rocm-libraries
 Priority: optional
 Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/rocm-team/hipfft.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/hipfft
-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
 Uploaders: Cordell Bloor <cgmb@debian.org>,
+           Maxime Chambonnet <maxzor@maxzor.eu>,
            Christian Kastner <ckk@debian.org>,
            Kari Pahula <kaol@debian.org>,
 Build-Depends: debhelper-compat (= 13),
-               hipcc (>= 5.6.1~),
+               hipcc (>= 7.1.0~),
                cmake,
                rocm-cmake,
-               librocfft-dev (>= 6.4.1~),
+               librocfft-dev (>= 7.1.0~),
                libboost-program-options-dev <!nocheck>,
                libfftw3-dev <!nocheck>,
+               libhiprand-dev (>= 7.1.0~) <!nocheck>,
                libgtest-dev <!nocheck>,
-               pkg-rocm-tools (>= 0.9.0~exp3),
+               pkg-rocm-tools (>= 0.9.4~),
 Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
                python3-doxysphinx <!nodoc>,
-               python3-rocm-docs (>= 1.20.0-1~) <!nodoc>,
+               python3-rocm-docs (>= 1.31.1-3~) <!nodoc>,
                python3-sphinx-external-toc <!nodoc>,
                libjs-jquery <!nodoc>,
                libjs-mathjax <!nodoc>,
@@ -30,7 +33,7 @@
 
 Package: libhipfft0
 Section: libs
-Architecture: amd64 arm64 ppc64el
+Architecture: amd64 arm64
 XB-X-ROCm-GPU-Architecture: ${rocm:GPU-Architecture}
 Depends: ${misc:Depends}, ${shlibs:Depends},
 Description: portable interface for Fast Fourier Transforms on the GPU - library
@@ -40,11 +43,24 @@
  .
  This package provides the AMD ROCm hipFFT library.
 
+Package: libhipfftw0
+Section: libs
+Architecture: amd64 arm64
+XB-X-ROCm-GPU-Architecture: ${rocm:GPU-Architecture}
+Depends: ${misc:Depends}, ${shlibs:Depends},
+Description: portable interface for Fast Fourier Transforms on the GPU - library
+ hipFFTW is a GPU-aware library for fast Fourier transforms using rocFFT as the
+ backend. It exports an interface borrowing the most commonly-used symbols of
+ FFTW. hipFFTW does not require its computational input and output to be
+ directly accessible by the GPU.
+ .
+ This package provides the AMD ROCm hipFFTW library.
+
 Package: libhipfft-dev
 Section: libdevel
-Architecture: amd64 arm64 ppc64el
-Depends: libhipfft0 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
-         libamdhip64-dev,
+Architecture: amd64 arm64
+Depends: libhipfft0 (= ${binary:Version}),libhipfftw0 (= ${binary:Version}),
+         ${misc:Depends}, ${shlibs:Depends}, libamdhip64-dev,
 Suggests: libhipfft-doc
 Description: portable interface for Fast Fourier Transforms on the GPU - headers
  hipFFT is a wrapper library that provides a common interface to rocFFT and
@@ -55,9 +71,10 @@
 
 Package: libhipfft0-tests
 Section: libdevel
-Architecture: amd64 arm64 ppc64el
+Architecture: amd64 arm64
 Build-Profiles: <!nocheck>
-Depends: libhipfft0 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
+Depends: libhipfft0 (= ${binary:Version}),libhipfftw0 (= ${binary:Version}),
+         ${misc:Depends}, ${shlibs:Depends},
 Description: portable interface for Fast Fourier Transforms on the GPU - tests
  hipFFT is a wrapper library that provides a common interface to rocFFT and
  cuFFT. The hipFFT library is designed to help applications using cuFFT to port
