=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,14 @@
 export CXX=hipcc
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
 export DEB_CXXFLAGS_MAINT_PREPEND = -gz
+# -Wl,--gc-sections:
+# Fixes linker errors ("relocation refers to a discarded section") when using gtest.
+# The linker's section garbage collection incorrectly discards needed code due to
+# a toolchain mismatch (ROCm's clang vs. the system's GCC). This flag forces the
+# linker to correctly re-evaluate dependencies, keeping the required sections.
+export DEB_LDFLAGS_MAINT_PREPEND = -Wl,--gc-sections
 export VERBOSE=1
+export DPKG_GENSYMBOLS_CHECK_LEVEL = 4
 
 # filter incompatible options from affecting device code
 CXXFLAGS := $(subst -fstack-protector-strong,-Xarch_host -fstack-protector-strong,$(CXXFLAGS))
@@ -17,8 +24,7 @@
 
 # The hipfft test client requires the rocfft sources to build.
 ifeq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
-CMAKE_FLAGS += -DBUILD_CLIENTS_TESTS=ON \
-	-DUSE_HIPRAND=OFF
+CMAKE_FLAGS += -DBUILD_CLIENTS_TESTS=ON
 endif
 
 %:
@@ -41,13 +47,15 @@
 	:
 
 override_dh_auto_build-indep:
+	:
+
+execute_after_dh_auto_build-indep:
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
-	http_proxy='127.0.0.1:9' \
-	https_proxy='127.0.0.1:9' \
-	ROCM_DOCS_REMOTE_DETAILS=http://localhost,local \
-	latest_version= \
-	release_candidate= \
-	sphinx-build -b html docs html
+	export https_proxy=127.0.0.1:9
+	export http_proxy=127.0.0.1:9
+	rocm-docs-build -t html
+	rm -rf html/_static/fonts
+	rm -rf html/_static/vendor
 endif
 
 override_dh_auto_test-indep:
